#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>

#define VERSION   "0.10"
#define DUMP_FILE "/crane/todo"
#define CRANE_EXE "/root/crane/Crane"
#define LOG_FILE  "/var/log/crane/crane.log"
#define DELAY_BW_EXE 1 /* Seconds */


typedef struct cmd
{
    int  id;
    char session[64];
    char user[64];
    char ip[16];
    char email[64];
    char hash[64];
    char command[128];
} Cmd;


Cmd get_cmd(char *str)
{
    Cmd cmd;

    cmd.id = atol(strtok(str, ","));
    strncpy(cmd.user, strtok(NULL, ","), sizeof(cmd.user));
    strncpy(cmd.ip, strtok(NULL, ","), sizeof(cmd.ip));
    strncpy(cmd.email, strtok(NULL, ","), sizeof(cmd.email));
    strncpy(cmd.hash, strtok(NULL, ","), sizeof(cmd.hash));
    strncpy(cmd.command, strtok(NULL, "\n"), sizeof(cmd.command));
    
    return cmd;
}


char *do_cmd(Cmd cmd)
{
    char *exe = malloc(sizeof(char) * 256);
    printf("Id:      %d\n"
           "User:    %s\n"
           "IP:      %s\n"
           "Email:   %s\n"
           "Hash:    %s\n"
           "Command: %s\n",
           cmd.id, cmd.user, cmd.ip, 
           cmd.email, cmd.hash, cmd.command);

    sprintf(exe, "%s -e %s -H %s %s", 
        CRANE_EXE, cmd.email, 
        cmd.hash, cmd.command);    
    system(exe);
    strcat(exe, "\n");
    
    return exe;
}


void to_log(
    FILE *fp,
    char *str)
{
   time_t timev = time(NULL);

   fprintf(fp, "%s %s", ctime(&timev), str);
   fflush(fp);
}   


int main(
    int    argc,
    char **argv)
{
    int   id;
    char  log_entry[128];
    char *cmdstr;
    char  dname[32]    = DUMP_FILE;
    char  log_name[32] = LOG_FILE;
    char  buf[128];
    FILE *log, *pipe;
    Cmd   cmd;

    if(!(log = fopen(log_name, "a")))
    {
            printf("Error opening log file: %s\n", log_name);
            exit(1);
    }

    fflush(log);
    
    if(!(pipe = fopen(dname, "w+")))
    {
        printf("Error opening pipe file descriptor: %s\n", dname);
        exit(1);
    }
    
    /* While shutdown is not a command */
    id = 0;
    while(!strstr(cmd.command, "shutdown"))
    {
        if(fgets(buf, 256, pipe))
        {
            cmd = get_cmd(buf);
            cmdstr = do_cmd(cmd);
            snprintf(log_entry, 256, "%d, %s, %s, %s, %s\n",
                cmd.id, cmd.ip, cmd.user, cmd.email, cmd.command);
            to_log(log, log_entry);
            
            memset(log_entry, 0, sizeof(log_entry));
            free(cmdstr);
            sleep(DELAY_BW_EXE);
        }
    }
   
    /* Huh huh Beavis its a pipe log huh huh */ 
    fclose(pipe);
    fclose(log);
    
    return 0;
}
