#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#define DUMP_DIR "/tmp/dump/dump"
#define MAX_PER_PIPE 1
#define MAX_IN_QUEUE 10

typedef struct cmd
{
    char user[50];
    char ip[16];
    char command[30];
} Cmd;


Cmd get_cmd(char *str)
{
    Cmd cmd;

    strcpy(cmd.user, (char *)strtok(str, ","));
    strcpy(cmd.ip, (char *)strtok(NULL, ","));
    strcpy(cmd.command, (char *)strtok(NULL, "\n"));

    return cmd;
}


void do_cmd(Cmd cmd)
{
    printf("User: %s\n"
           "ip:   %s\n"
           "Command: %s\n",
           cmd.user, cmd.ip, cmd.command);
}


int main(
    int    argc,
    char **argv)
{
    int desc, i;
    int limit = 0;
    char dname[32] = DUMP_DIR;
    Cmd cmd;
    void *buf = malloc(sizeof(char)*200);

    if(!(desc = open(dname, O_RDWR | O_CREAT | O_TRUNC)))
    {
        printf("Error opening file desctiptor: %s\n", dname);
        _Exit(1);
    }
    
    /* While shutdown is not a command */
    while(!strstr(cmd.command, "shutdown"))
    {
        if(read(desc, buf, 100))
        {
            if((char*) buf)
            {
                cmd = get_cmd((char *)buf);
                do_cmd(cmd);
                limit++;
            }

            /* Truncate the file (save room) */
            if(limit > MAX_PER_PIPE)
            {
                limit = 0;
                close(desc);
                desc = open(dname, O_RDWR | O_CREAT | O_TRUNC);
            }
        }
    }
    close(desc);
    
    return 0;
}
